; 
    include \masm32\include\masm32rt.inc

    DlgProc       PROTO :DWORD,:DWORD,:DWORD,:DWORD
    GroupBoxProc  PROTO :DWORD,:DWORD,:DWORD,:DWORD 

    .data
        hInstance       dd 0
        oldGroupBoxProc dd 0
        hBrush          dd 0
    .code
; 
start:

      mov hInstance, rv(GetModuleHandle,NULL)
      call Main
      invoke ExitProcess, eax

; 

Main proc
    Dialog "TEST","MS Sans Serif",8,WS_OVERLAPPEDWINDOW,\
            2,5,5,80,60,1024
    DlgGroup "xxx",10,4,60,30,1000
    DlgButton "Set BG",WS_TABSTOP,25,42,30,10,1001
    CallModalDialog hInstance,0,DlgProc,NULL
    ret
Main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .IF uMsg == WM_INITDIALOG

      ;-------------------------
      ; Subclass the group box.
      ;-------------------------

      invoke GetDlgItem,hWin,1000
      invoke SetWindowLong,eax,GWL_WNDPROC,GroupBoxProc
      mov oldGroupBoxProc, eax

    .ELSEIF uMsg == WM_COMMAND

      .IF wParam == 1001

        invoke GetStockObject,BLACK_BRUSH
        mov   hBrush, eax

        ;------------------
        ; Force a repaint.
        ;------------------
        invoke GetDlgItem,hWin,1000
        invoke InvalidateRect,eax,NULL,TRUE

      .ENDIF

    .ELSEIF uMsg == WM_CLOSE
        
       invoke EndDialog, hWin, 0

    .ENDIF

    return 0

DlgProc endp

; 

GroupBoxProc proc hCtl:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hBrushOld :DWORD
    LOCAL hDC       :DWORD
    LOCAL rc        :RECT

    .IF uMsg == WM_ERASEBKGND && hBrush

      ;---------------------------------------------------
      ; To override the class background brush we must
      ; handle all background erase events for the group
      ; box, substituting the new background color.
      ;---------------------------------------------------

      m2m   hDC, wParam
      
      invoke SelectObject,hDC,hBrush

      invoke GetClientRect,hCtl,ADDR rc
      mov   ecx, rc.right
      sub   ecx, rc.left
      add   ecx, 1
      mov   edx, rc.bottom
      sub   edx, rc.top
      add   edx, 1
           
      invoke PatBlt,hDC,rc.left,rc.top,ecx,edx,PATCOPY
            
      invoke SelectObject,hDC,hBrushOld

      ;----------------------------------------------
      ; Bypass the call to the default window proc.
      ;----------------------------------------------

      return 0

    .ENDIF

    invoke CallWindowProc,oldGroupBoxProc,hCtl,uMsg,wParam,lParam
    ret

GroupBoxProc endp

; 
end start
